# Think Penguin [TPE-R1200 mini WiFi Router v2](https://www.thinkpenguin.com/gnu-linux/free-software-wireless-n-mini-vpn-routerv2-tpe-r1200)

## Specs

* SoC: Atheros AR9331
* RAM: 64M
* Flash: 16M NOR + 128M SPI NAND
* NIC: 2 10/100 Ethernet Ports
* USB: 1
* WiFi: Atheros 802.11b/g/n 2.4Ghz
* GPIO: 3 General Purpose and one switch.
* Power: 5v USB

The TPE-R1200 is a general purpose mini WiFi router
that can be used for a wide range of applications. 
Some common uses include:

* Route all traffic over a VPN when on the go.
* WiFi to ethernet bridge.
* A small web server.
* IRC bouncer.
* Meshnet node (CJDNS, Batman...).

# Notes

With the release of v1.5.0, NAND flash support is not available yet. Before upgrading the router,
the u-boot environment variable `bootcount` needs to be set higher than 3. This can be achieved
by ssh'ing into the router and running : 


`fw_setenv bootcount 4` 


After rebooting the router,the router can be upgraded using a `nor` image. When upgrading, it is important that any settings
are not saved and that the "Keep Settings" box is unchecked in luci or that the `-n` flag is specified when using `sysupgrade`.

# Firmware Images

See our [flavors](https://librecmc.org/flavors.html) page for a description of each type of libreCMC image.

## Main

[TPE-R1200 NOR](https://librecmc.org/librecmc/downloads/snapshots/current/main/targets/ath79/generic/librecmc-ath79-generic-thinkpenguin_tpe-r1200-nor-squashfs-sysupgrade.bin)

## Core

[TPE-R1200 NOR](https://librecmc.org/librecmc/downloads/snapshots/current/core/targets/ath79/generic/librecmc-ath79-generic-thinkpenguin_tpe-r1200-nor-squashfs-sysupgrade.bin)

## Image File Signatures 

[Main sha256sums](https://librecmc.org/librecmc/downloads/snapshots/current/main/targets/ath79/generic/sha256sums)

[Main sha256sums.asc](https://librecmc.org/librecmc/downloads/snapshots/current/main/targets/ath79/generic/sha256sums.asc)


[Core sha256sums](https://librecmc.org/librecmc/downloads/snapshots/current/core/targets/ath79/generic/sha256sums)

[Core sha256sums.asc](https://librecmc.org/librecmc/downloads/snapshots/current/core/targets/ath79/generic/sha256sums.asc)

